library IEEE;
use IEEE.std_logic_1164.all;

entity Counter is
  port (r,z,c       : IN STD_LOGIC;
        q0,q1,q2  : OUT STD_LOGIC);
end Counter;

architecture Behaviour of Counter is

  component jk_flipflop
    port (j,k,c : IN STD_LOGIC;
          q,qn: OUT STD_LOGIC);	  
  end component;

   signal q00,q11,q22,qn00,qn11,qn22,j0,j1,j2,k0,k1,k2 : STD_LOGIC;

begin

  -- Zaehler benoetigt drei Flip-Flops
  jk_0 : jk_flipflop port map( j0,k0,c,q00,qn00 );
  jk_1 : jk_flipflop port map( j1,k1,c,q11,qn11 );
  jk_2 : jk_flipflop port map( j2,k2,c,q22,qn22 );
  
  -- erstes Flip Flop definieren
  j0 <= (q11 and z) or r;
  k0 <= (qn22 and z) and (not r);
  
  -- zweites Flip Flop definieren
  j1 <= (q22 and z) or r;
  k1 <= (q00 and z) and (not r);
  
  -- drittes Flip Flop definieren
  j2 <= ((not q00) and z) and (not r);
  k2 <= (q22 and (not q11)) or r;
  
  -- Jetzt die Ausgabewerte der Flip Flops zurueckgeben
  q0 <= q00;
  q1 <= q11;
  q2 <= q22;
  
end Behaviour;
