library IEEE;
use IEEE.std_logic_1164.all;

entity counter_stim is
end counter_stim;

architecture Test of counter_stim is
  component clock
    port (c      : OUT STD_LOGIC);
  end component;

  component counter
    port (r,z,c       : IN STD_LOGIC;
          q0,q1,q2  : OUT STD_LOGIC);
  end component;

  signal  c_test, r_test, z_test, q0_test, q1_test, q2_test: STD_LOGIC;

begin
  -- wir benoetigen einen Counter ...
  counter_test: counter port map (
			         r_test,
				 z_test,
				 c_test,
				 q0_test,
				 q1_test,
				 q2_test
			      );
			      
  -- ... und einen Takt dafuer			    
  clock_test: clock port map (c_test);
	   
  -- 'z' ist der Eingang der zum Anhalten fuehrt
  z_test <= '0' after 0 ns,
	    '1' after 100 ns, 
	    '0' after 1000 ns,
	    '1' after 1400 ns,
	    '0' after 3000 ns;  
	 
  -- 'r' ist der Eingang der den Startzustand setzt	 
  r_test <= '1' after 0 ns,
	    '0' after 100 ns, 
	    '1' after 2000 ns,
	    '0' after 2400 ns;  
	    
end Test;
