library IEEE;
use IEEE.std_logic_1164.all;

entity D_FlipFlop is
  generic (tsu,th,tphl,tplh,thalbe : time);
  port (d,c : IN STD_LOGIC;
        q,qn: OUT STD_LOGIC);
end D_FlipFlop;

architecture Behaviour of D_FlipFlop is
  signal Flag : STD_LOGIC;
begin
  
  Ausgang: process -- keine sensitivity list, da wait/until-konstrukt
  begin
    
       wait until (c='1') or (d'event); -- Auf Takt- oder D-Wechsel warten
       
       -- nderung erfolgt nur, wenn d gewechselt, Takt auf 1 und Flag auf 0
       if (d/=d'last_value) and (c='1') and (Flag='0') then 
       
          if (d='1') then -- Q: 0 -> 1
             wait for tplh; 
          else -- d='0'
             wait for tphl; -- Q: 1 -> 0
          end if;
             
          q <= d;
          qn <= not d;
      
       end if;
   
  end process;  
  
  Validation: process
  begin
  
       wait until (c'event); -- clock mu wechseln -> Flanke
       
       if (c='0') then
          Flag <= '1'; -- q (Ausgang) verriegeln
          wait for th;
          Flag <= '0';
       else -- c='1'
          Flag <= '0'; -- q (Ausgang) freigeben
          wait for (thalbe-tsu);
          Flag <= '1';       
       end if;  
  
  end process;  
  
end Behaviour;
