library IEEE;
use IEEE.std_logic_1164.all;

entity d_flipflop_stim is
end d_flipflop_stim;

architecture Test of d_flipflop_stim is
  component d_flipflop
    generic (tsu,th,tphl,tplh,thalbe : time);
    port (d,c : IN STD_LOGIC;
          q,qn: OUT STD_LOGIC);	  
  end component;

  component clock
    port (c      : OUT STD_LOGIC);
  end component;

  signal  d_test, c_test, q_test, qn_test: STD_LOGIC;

begin
  d_flipflop_test: d_flipflop generic map(
  			         20 ns,
				 5 ns,
				 10 ns,
				 15 ns,
				 50 ns
			      ) 
			      port map (
			         d_test,
				 c_test,
				 q_test,
				 qn_test
			      );
  clock_test: clock port map (c_test);

  d_test <= '0' after 0 ns,
	    '1' after 90 ns,   -- 10 ns vor fallender Flanke
	    
	    '0' after 202 ns,  -- 2 ns nach der fallenden Flanke

	    '1' after 275 ns,  -- 25 ns nach steigender Flanke

	    '0' after 375 ns;  -- 25 ns nach steigender Flanke 
	   
end Test;
