library IEEE;
use IEEE.std_logic_1164.all;

entity JK_FlipFlop is
  port (j,k,c : IN STD_LOGIC;
       q,qn: OUT STD_LOGIC);
end JK_FlipFlop;

architecture Behaviour of JK_FlipFlop is
signal q_intern : STD_LOGIC;
begin
  
  Ausgang: process -- keine sensitivity list, da wait/until-konstrukt
  begin
    
       wait until (c'event); -- Auf Taktflanke warten
       
       -- Fallunterscheidung, ob Takt steigt oder faellt
       if (c='1') then
           -- 1. Fall: loeschen
           if (j='0') and (k='1') then
	      q_intern <= '0';
	   end if;

           -- 2. Fall: setzen
           if (j='1') and (k='0') then
	      q_intern <= '1';
	   end if;

           -- 3. Fall: invertieren
           if (j='1') and (k='1') then
	      q_intern <= not q_intern;
	   end if;
       else
           q <= q_intern;
	   qn <= not q_intern;
       end if;
   
  end process;  
  
end Behaviour;
