library IEEE;
use IEEE.std_logic_1164.all;

entity jk_flipflop_stim is
end jk_flipflop_stim;

architecture Test of jk_flipflop_stim is
  component jk_flipflop
    port (j,k,c : IN STD_LOGIC;
          q,qn: OUT STD_LOGIC);	  
  end component;

  component clock
    port (c      : OUT STD_LOGIC);
  end component;

  signal  j_test, k_test, c_test, q_test, qn_test: STD_LOGIC;

begin
  jk_flipflop_test: jk_flipflop port map (
			         j_test,
				 k_test,
				 c_test,
				 q_test,
				 qn_test
			      );
  clock_test: clock port map (c_test);

  j_test <= '0' after 0 ns,
	    '1' after 120 ns,   
	    '0' after 220 ns,  
	    '1' after 320 ns,  
	    '0' after 420 ns,  
	    '1' after 520 ns,  
	    '0' after 620 ns,  
	    '1' after 720 ns,  
	    '0' after 820 ns,  
	    '1' after 920 ns,  
	    '0' after 1020 ns;  
	    
  k_test <= '1' after 0 ns,
	    '1' after 120 ns,   
	    '0' after 220 ns,  
	    '0' after 320 ns,  
	    '1' after 420 ns,  
	    '1' after 520 ns,  
	    '0' after 620 ns,  
	    '0' after 720 ns,  
	    '0' after 820 ns,  
	    '0' after 920 ns,  
	    '0' after 1020 ns;  
	    
end Test;
